<?php

declare(strict_types=1);

namespace Drupal\livewire_field\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\Attribute\FieldFormatter;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Plugin implementation of the 'Wire Component Display' formatter.
 */
#[FieldFormatter(
  id: 'wire_component_formatter',
  label: new TranslatableMarkup('Wire Component Display'),
  field_types: ['wire_component'],
)]
class WireComponentFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode): array {
    $element = [];
    foreach ($items as $delta => $item) {
      $element[$delta] = [
        '#type' => 'wire',
        '#id' => $item->plugin_id,
      ];
    }
    return $element;
  }

}
